uses dos,crt,graph;
type
Location = object  		               {ꥪ - , ।}
x,y :integer;
procedure Init(InitX,InitY : integer);
function GetX : integer;
function GetY : integer;
end;
Point = object(Location) 	               {ꥪ - 窠, ⮬ 樨}
visible : boolean;
constructor Init(InitX, InitY : integer);
procedure Show ;virtual;                       {㠫 ⮤}
procedure Hide; virtual;                       {㠫 ⮤}
function IsVisible : boolean;
procedure MoveTo(NewX, NewY : integer);
end;
Circle = object(Point)		               {ꥪ-㦭, ⮬ 窨}
radius : integer;
constructor Init(InitX, InitY : integer;
                   InitRadius : integer);
procedure Show; virtual;                       { ⮬ 㠫쭮}
procedure Hide; virtual;                       { ⮬ 㠫쭮}
procedure Expand(ExpandBy : integer);
procedure Contract(ContractBy : integer);
{procedure MoveTo(NewX, NewY : integer);  }
end;


{᫥ ᠭ ꥪ⮢ ᫥ ᠭ ⮤ ꥪ⮢}
   procedure Location.Init(InitX,InitY : integer);
   begin
     x:=InitX;
     y:=InitY;
   end;

   function Location.GetX : integer;
   begin
     GetX:=x;
   end;

   function Location.GetY : integer;
   begin
     GetY:=y;
   end;

  constructor Point.Init(InitX, InitY : integer);
  begin
    Location.Init(InitX, InitY);
    visible:=false;
  end;

  procedure Point.Show ;
  begin
    visible:=true;
    putpixel(x,y,getcolor);
  end;

  procedure Point.Hide ;
  begin
    visible:=false;
    putpixel(x,y,getbkcolor);
  end;

  function Point.IsVisible;
  begin
    IsVisible:=visible;
  end;

  procedure Point.MoveTo(NewX,NewY:integer);
  begin
    Hide;
    x:=NewX;
    y:=NewY;
    Show;
  end;

  constructor Circle.Init(InitX, InitY, InitRadius : integer);
  begin
    Point.Init(InitX,InitY);
    radius:=InitRadius;
  end;
  procedure Circle.Show;
  begin
    visible:=true;
    Graph.Circle(x,y,radius);
  end;

  procedure Circle.Hide;
  var
  tempcolor:word;
  begin
    tempcolor:=getcolor;			{ ⥪騩 梥}
    setcolor(getbkcolor); 		        {࠭-梥 䮭!   }
    visible:=false;
    Graph.Circle(x,y,radius);
    setcolor(tempcolor); 		        {⠭ 梥  }
  end;

  procedure Circle.Expand(ExpandBy : integer);
  begin
    Hide;
    radius:=radius+ExpandBy;
    if radius<0 then radius:=0;
    Show;
  end;

  procedure Circle.Contract(ContractBy : integer);
  begin
    Expand(-ContractBy); 		          {ᯮ짮 ⮢ ⮤!}
  end;

{  procedure Circle.MoveTo(NewX, NewY : integer);
  begin
    Hide;
    x:=NewX;
    y:=NewY;
    Show;
  end;
 }
 var
 driver,mode:integer;
 MyCircle:Circle;
 begin 						{᭮ ணࠬ}
    {樠 ᪮ ०}
    driver:=9; mode:=2;
    initgraph(driver,mode,'C:\bp\bgi');

    MyCircle.Init(100,200,50); 	                {ᮧ 㦭}
    MyCircle.Show; 				{ 㦭}
    readkey; 					{  }
    MyCircle.MoveTo(200,250); 	                {। 㦭}
    readkey;
    MyCircle.Expand(50); 	                {㢥 ࠤ  50}
    readkey;
    MyCircle.Contract(75); 	                {㬥 ࠤ  75}
    readkey;
    closegraph;
  end.

